<?php
/* 
Plugin Name: Peter's Picnik-WordPress interaction
Plugin URI: http://www.theblog.ca?p=164
Description: Brings Picnik editing capabilities to your WordPress admin panel. I have no plans to further develop this plugin, so please feel free to use any of the code in it to develop your own plugin! I'll be happy to promote your better plugin on my blog!
Author: Peter Keung
Version: alpha
Author URI: http://www.theblog.ca
*/

//--------------------------
// SETTINGS (only one)
//--------------------------


// Enter your picnik.com API key here!
$picnik_api = 'PUT YOUR API KEY HERE. GET ONE FOR FREE AT PICNIK.COM';


//--------------------------
// CODE (developers only!
//--------------------------


function ppw_interface() {
	global $post_id, $picnik_api;
?>
<div name="picnik_space" style="height: 20px;"></div>
<?php
	if (isset($_POST['post_title'])) {
		global $from_tab, $style;
		
		// Scope the URL returned by Picnik to a global variable so that we can work with it
		$picnik_url = urldecode($_POST['picnik_url']);
		
		if ( !$from_tab )
			$from_tab = 'upload';

		// A WordPress check so that the form was internally generated
		check_admin_referer( 'inlineuploading' );

		global $post_id, $post_title, $post_content;

		// Runs a check to see whether the user even had the correct privileges to "upload" a file
		if ( !current_user_can( 'upload_files' ) )
			wp_die( __('You are not allowed to upload files.')
				. " <a href='" . get_option('siteurl') . "/wp-admin/upload.php?style=" . attribute_escape($style . "&amp;tab=browse-all&amp;post_id=$post_id") . "'>"
				. __('Browse Files') . '</a>'
			);

		// Find out what's the upload directory
		$uploads = wp_upload_dir();
		
		// What's the file extension?
		$picnik_ext = ltrim(strrchr($picnik_url, '.'), '.');
		
		// Construct a temporary file name (without extension) from the post title (well, only temporary if the file name already exists)
		$picnik_filename = sanitize_title_with_dashes($post_title);
		
		// Increment the file number until we have a unique file to save in $dir. Stolen from WordPress file.php)
		$number = '';
		$picnik_filename = str_replace( '#', '_', $picnik_filename );
		$picnik_filename = str_replace( array( '\\', "'" ), '', $picnik_filename );
		
		// If there's no extension, there's no point in adding the period
		if ( empty( $picnik_ext) )
			$picnik_ext = '';
		else
			$picnik_ext = ".$picnik_ext";
			
		// File name with extension
		$picnik_filename = $picnik_filename . $picnik_ext;
		
		// Add a number to the filename as many times as needed until we have a unique file name		
		while ( file_exists( $uploads['path'] . "/$picnik_filename") ) {
			$picnik_filename = str_replace( "$number$picnik_ext", ++$number . $picnik_ext, $picnik_filename );
		}
		
		// This is the finally, unoccupied path for the file
		$picnik_path = $uploads['path'] . '/' . $picnik_filename;
		
		// Copy the outputted image from Picnik and put it on the local upload directory
		file_put_contents($picnik_path, file_get_contents($picnik_url));
		
		// Returns an array with 0 -> width; 1 -> height; 2-> image type; 3-> text string with width and height
		$picnik_data = getimagesize($picnik_path);
		
		// Converts the image type from the getimagesize function to the MIME type appropriate for database storage
		$picnik_type = image_type_to_mime_type($picnik_data[2]);
		
		// What will the URL be
		$picnik_url = $uploads['url'] . "/$picnik_filename";
		
		// Set correct file permissions
		$stat = stat($uploads['path']);
		$perms = $stat['mode'] & 0000666;
		@ chmod( $picnik_path, $perms );
	
		// Construct the attachment array
		$attachment = array(
			'post_title' => $post_title,
			'post_content' => $post_content,
			'post_type' => 'attachment',
			'post_parent' => $post_id,
			'post_mime_type' => $picnik_type,
			'guid' => $picnik_url
		);
		// Save the data
		$id = wp_insert_attachment($attachment, $picnik_path, $post_id);

		wp_update_attachment_metadata( $id, wp_generate_attachment_metadata( $id, $picnik_path ) );
		
		$picnik_link = get_option('siteurl') . "/wp-admin/upload.php?style=inline&tab=browse&action=view&ID=$id&post_id=$post_id";
		print "<p><a href=\"$picnik_link\">Image uploaded! Click here to view and insert it</a>.</p>";
		die;
		break;
}
	// Submit the image!
	elseif (isset($_GET['image'])){
?>
	<form id="upload-file" method="post" action="<?php print get_option('siteurl') . "/wp-admin/upload.php?style=inline&amp;tab=picniktab&amp;post_id=" . $post_id; ?>">
		<table><col /><col class="widefat" />
			<tr>
				<th scope="row">Image (thumbnail only)</th>
				<td><img src="<?php print $_GET['image']; ?>" style="width: 300px;" alt="Yes, I know this is a crude way of displaying the thumbnail" /></a></td>
			<tr>
				<th scope="row"><label for="post_title">Title</label></th>
				<td><input type="text" id="post_title" name="post_title" value="" /></td>
			</tr>
			<tr>
				<th scope="row"><label for="post_content">Description</label></th>

				<td><textarea name="post_content" id="post_content"></textarea></td>
			</tr>
			<tr id="buttons" class="submit">
				<td colspan='2'>
					<input type="hidden" name="picnik_url" value="<?php print urlencode($_GET['image']);?>" />
					<input type="hidden" name="from_tab" value="upload" />
					<input type="hidden" name="action" value="upload" />
					<input type="hidden" name="post_id" value="<?php print $post_id; ?>" />
					<?php wp_nonce_field( 'inlineuploading' );?>
					<div class="submit">
						<input type="submit" value="Add image &raquo;" />
					</div>
				</td>
			</tr>
		</table>
	</form>
<?php
}

	// You have received the image back from Picnik... so do something about it!
	else {
	// Show the upload form
?>
<form method="post" action="http://www.picnik.com/service/" enctype='multipart/form-data'>
	<table><col /><col class="widefat" />
		<tr>
			<th scope="row"><label for="upload">Image</label></th>
			<td><input type="hidden" name="_import" value="image" />
			<input type="hidden" name="_export" value="<?php print get_option('siteurl') . '/wp-admin/upload.php?style=inline&amp;tab=picniktab&amp;post_id=' . $post_id . '&amp;'; ?>" />
			<input type="hidden" name="_export_title" value="Send it back to my WordPress site!" />
			<input type="hidden" name="_export_field" value="image" />
			<input type="hidden" name="_export_agent" value="browser" />
			<input type="hidden" name="_export_method" value="GET" />
			<input type="file" id="image" name="image" size="30" >
			<input type="hidden" name="_apikey" value="<?php print $picnik_api; ?>" />
			<br />
			<input type="submit" value="Upload to Picnik"/></td>
		</tr>
</table>
</form>
<?php
	}
}

// Function to add the Picnik tab to the upload window
function ppw_add_picniktab($tabs) {
	$tabs['picniktab'] = array('Picnik', 'upload_files', 'ppw_interface', 0);
	return $tabs;
}

	// Hooks so that our functions actually interact with WordPress!
	add_filter('wp_upload_tabs', 'ppw_add_picniktab');
	add_action('upload_files_picnik', 'ppw_interface');
?>